#line 1 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/common files/types.h"
#line 20 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/common files/types.h"
enum TMcuType {mtPIC16 = 1, mtPIC18, mtPIC18FJ, mtPIC24, mtDSPIC = 10, mtPIC32 = 20};


enum TBootInfoField {bifMCUTYPE=1,
 bifMCUID,
 bifERASEBLOCK,
 bifWRITEBLOCK,
 bifBOOTREV,
 bifBOOTSTART,
 bifDEVDSC,
 bifMCUSIZE
 };


enum TCmd {cmdNON=0,
 cmdSYNC,
 cmdINFO,
 cmdBOOT,
 cmdREBOOT,
 cmdWRITE=11,
 cmdERASE=21};




typedef struct {
 char fFieldType;
 char fValue;
} TCharField;


typedef struct {
 char fFieldType;
 union {
 unsigned int intVal;
 struct {
 char bLo;
 char bHi;
 };
 } fValue;
} TUIntField;


typedef struct {
 char fFieldType;
 unsigned long fValue;
} TULongField;



typedef struct {
 char fFieldType;
 char fValue[ 20 ];
} TStringField;


typedef struct {
 char bSize;
 TCharField bMcuType;
 TULongField ulMcuSize;
 TUIntField uiEraseBlock;
 TUIntField uiWriteBlock;
 TUIntField uiBootRev;
 TULongField ulBootStart;
 TStringField sDevDsc;
} TBootInfo;
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/common files/types.h"
#line 29 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
extern const unsigned long MCU_FLASH_START_PHY;
extern const unsigned long MCU_BOOT_FLASH_START_PHY;
extern const unsigned long MCU_BOOT_FLASH_CONFIG_BLOCK_START_PHY;


extern const unsigned long BOOTLOADER_SIZE;
extern const unsigned long BOOTLOADER_START;
extern const unsigned long BOOTLOADER_START_PHY;
extern const unsigned char RESET_VECTOR_SIZE;

extern const TBootInfo BootInfo;


extern unsigned char HidReadBuff[64];
extern unsigned char HidWriteBuff[64];
#line 66 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
void Config();
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 102 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
const STX = 0x0F;
const ETX = 0x04;
const DLE = 0x05;

int GPCounter = 0;
int BytesToWrite at GPCounter;
int BytesToGet at GPCounter;
int BlocksToErase at GPCounter;

unsigned long GPAddress = 0;
unsigned long StartAddress at GPAddress;


struct {
 char fBuffer[_FLASH_ERASE];
 char *fRWPtr;
#line 129 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
} Buffer;

enum TCmd CmdCode = cmdNON;
#line 155 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
static void _Buffer_SaveToFlash() {
 int bCount;

 bCount =  Buffer.fRWPtr-Buffer.fBuffer ;
 Buffer.fRWPtr = Buffer.fBuffer;
 while (bCount > 0) {
  FLASH_Write_Word(StartAddress, *(long *)Buffer.fRWPtr) ;
 bCount -=  4 ;
 Buffer.fRWPtr +=  4 ;



 StartAddress +=  4 ;

 }
}
#line 194 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
static void SendBootInfo() {
 typedef struct {
 char fArray[sizeof(TBootInfo)];
 } TBootInfoArray;



 *(TBootInfoArray *)(void *)HidWriteBuff = BootInfo;
 HID_Write(HidWriteBuff, 64);
}
#line 227 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
static void Check4Cmd() {
 if (CmdCode == cmdNON) {

 if (HidReadBuff[0] != STX)

 return ;


 CmdCode = HidReadBuff[1];
  ((char *)&GPAddress)[0]  = HidReadBuff[2];
  ((char *)&GPAddress)[1]  = HidReadBuff[3];
  ((char *)&GPAddress)[2]  = HidReadBuff[4];
  ((char *)&GPAddress)[3]  = HidReadBuff[5];
  ((char *)&GPCounter)[0]  = HidReadBuff[6];
  ((char *)&GPCounter)[1]  = HidReadBuff[7];
 }
 else {

 }
}
#line 275 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
static char GetData() {
 char i;
 char *sPtr;


 sPtr = HidReadBuff;
 i = 0;
 while (1) {
 if (!BytesToGet)
 return 1;
 if ( Buffer.fRWPtr-Buffer.fBuffer  ==  sizeof(Buffer.fBuffer) )
 return 1;
 if (i == sizeof(HidReadBuff))
 return 0;
  *Buffer.fRWPtr++ = *sPtr++ ;
 BytesToGet--;
 i++;
 }
 return 0;
}
#line 317 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
static void SendACK(enum TCmd cmd) {

 HidWriteBuff[0] = STX;
 HidWriteBuff[1] = cmd;
 HID_Write(HidWriteBuff, 64);
}
#line 345 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
void StartBootloader() {
 char dataRx;
 char writeData = 0;

  Buffer.fRWPtr = Buffer.fBuffer ;


 while(1) {

 dataRx = HID_Read();
 if (dataRx) {
 dataRx = 0;
 Check4Cmd();
 switch(CmdCode) {
 case cmdWRITE: {
 if (writeData) {
 if (GetData()) {

 if ((StartAddress < BOOTLOADER_START_PHY) ||
 ((StartAddress >= MCU_BOOT_FLASH_START_PHY) &&
 (StartAddress < MCU_BOOT_FLASH_CONFIG_BLOCK_START_PHY)))
#line 369 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
  _Buffer_SaveToFlash() ;
 SendACK(CmdCode);
  Buffer.fRWPtr = Buffer.fBuffer ;
 if (BytesToWrite == 0) {
 writeData = 0;
 CmdCode = cmdNON;
 }
 }
 }
 else {
 writeData = 1;
 }
 break;
 }
 case cmdERASE: {
 while (BlocksToErase--) {

 if ((StartAddress < BOOTLOADER_START_PHY) ||
 ((StartAddress >= MCU_BOOT_FLASH_START_PHY) &&
 (StartAddress < MCU_BOOT_FLASH_CONFIG_BLOCK_START_PHY)))
#line 392 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
  FLASH_Erase_Page (StartAddress);



 StartAddress -= _FLASH_ERASE;

 }
 SendACK(CmdCode);
 CmdCode = cmdNON;
 break;
 }
 case cmdSYNC: {
 SendACK(CmdCode);
 CmdCode = cmdNON;
 break;
 }
 case cmdREBOOT: {
#line 416 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
 Reset();

 CmdCode = cmdNON;
 break;
 }
 }
 }
 }
}
#line 451 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
char EnterBootloaderMode() {
char dataRx,
 timer = 500;


 while (1) {

 dataRx = HID_Read();
 if (dataRx) {
 dataRx = 0;
 Check4Cmd();
 switch (cmdCode) {
 case cmdBOOT: {
 SendACK(CmdCode);
 CmdCode = cmdNON;
 Delay_10ms();
 return 1;
 }
 case cmdINFO: {
 SendBootInfo();
 CmdCode = cmdNON;
 break;
 }
 }
 }

 Delay_10ms();
 Delay_10ms();
 if (!(timer--))
 return 0;
 }
}
#line 508 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Driver/UHB_Driver.c"
void StartProgram() {

 asm nop;

 asm nop;

}
