#line 1 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Projects/Common Files/Main.c"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/common files/types.h"
#line 20 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/common files/types.h"
enum TMcuType {mtPIC16 = 1, mtPIC18, mtPIC18FJ, mtPIC24, mtDSPIC = 10, mtPIC32 = 20};


enum TBootInfoField {bifMCUTYPE=1,
 bifMCUID,
 bifERASEBLOCK,
 bifWRITEBLOCK,
 bifBOOTREV,
 bifBOOTSTART,
 bifDEVDSC,
 bifMCUSIZE
 };


enum TCmd {cmdNON=0,
 cmdSYNC,
 cmdINFO,
 cmdBOOT,
 cmdREBOOT,
 cmdWRITE=11,
 cmdERASE=21};




typedef struct {
 char fFieldType;
 char fValue;
} TCharField;


typedef struct {
 char fFieldType;
 union {
 unsigned int intVal;
 struct {
 char bLo;
 char bHi;
 };
 } fValue;
} TUIntField;


typedef struct {
 char fFieldType;
 unsigned long fValue;
} TULongField;



typedef struct {
 char fFieldType;
 char fValue[ 20 ];
} TStringField;


typedef struct {
 char bSize;
 TCharField bMcuType;
 TULongField ulMcuSize;
 TUIntField uiEraseBlock;
 TUIntField uiWriteBlock;
 TUIntField uiBootRev;
 TULongField ulBootStart;
 TStringField sDevDsc;
} TBootInfo;
#line 29 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
extern const unsigned long MCU_FLASH_START_PHY;
extern const unsigned long MCU_BOOT_FLASH_START_PHY;
extern const unsigned long MCU_BOOT_FLASH_CONFIG_BLOCK_START_PHY;


extern const unsigned long BOOTLOADER_SIZE;
extern const unsigned long BOOTLOADER_START;
extern const unsigned long BOOTLOADER_START_PHY;
extern const unsigned char RESET_VECTOR_SIZE;

extern const TBootInfo BootInfo;


extern unsigned char HidReadBuff[64];
extern unsigned char HidWriteBuff[64];
#line 66 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/projects/pic32/config.h"
void Config();
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/driver/uhb_driver.h"
#line 19 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/examples/other/usb hid bootloader/driver/uhb_driver.h"
void StartProgram();
void StartBootloader();
char EnterBootloaderMode();
#line 77 "C:/Program Files (x86)/MikroElektronika/mikroC PRO for PIC32/Examples/Other/USB HID Bootloader/Projects/Common Files/Main.c"
void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
 USB_Interrupt_Proc();
 USBIF_bit = 0;
}

void main(void) {
 Config();

 USBIP0_bit = 1;
 USBIP1_bit = 1;
 USBIP2_bit = 1;

 USBIE_bit = 1;

 EnableInterrupts();

 HID_Enable(&HidReadBuff, &HidWriteBuff);


 if (!EnterBootloaderMode()) {
 HID_Disable();
 Delay_10ms();

 StartProgram();
 }
 else
 StartBootloader();
}
